(function() {
	tpl.at = {};
	
	//
	// Add the titles of the test cases to the list to get them loaded to the table view
	//
	tpl.at.createData = function () {
		var acceptanceData = [
		
		{title:'TIMOB5460', hasChild:true, level:"acceptance"},
		{title:'TIMOB5166', hasChild:true, level:"acceptance"},
		{title:'TIMOB7412', hasChild:true, level:"acceptance"},
		{title:'TIMOB7416', hasChild:true, level:"acceptance"},
		{title:'TIMOB7517', hasChild:true, level:"acceptance"}
		
		]
		
		return acceptanceData;
	};
	
	
	tpl.at.TIMOB5460 = function (_window) {
		
		_window.backgroundColor = 'black';
		
		var fromColor = '#2d6e32';
		var toColor = '#35883b';
		
		var v = Ti.UI.createView({
			width: '100dp',
			height: '100dp',
			backgroundColor: fromColor
		});
		
		var b = Ti.UI.createButton({
			title: 'Animate',
			width: 100,
			height: 30,
			bottom: '45dp',
			left: '45dp'
		});
		
		b.addEventListener('click', function() {
			v.animate({
				backgroundColor: toColor,
				duration: 500
			});
		});
		
		var b1 = Ti.UI.createButton({
			title: 'Reset',
			width: 100,
			height: 30,
			bottom: '45dp',
			right: '45dp'	
		});
		
		b1.addEventListener('click', function() {
			v.backgroundColor = toColor;
			v.backgroundColor = fromColor;
		});
		
		var v1 = Ti.UI.createView({
			width : '50dp',
			height: '50dp',
			backgroundColor: 'white'
		});
		
		_window.add(v);
		_window.add(b);
		_window.add(b1);
		_window.add(v1);

		return _window;
		
	};
	
	tpl.at.TIMOB5166 = function(_window){
		
		if(Titanium.Platform.name != 'iPhone OS'){
			_window.add(tpl.ui.getSkipLabel());
			return _window;
		}
		
		var data = [
			{title:'ANIMATION - [WARN]', hasChild:true, test:'/timob5166/warning_animation.js'},
			{title:'ANIMATION - NEW', hasChild:true, test:'/timob5166/no_warning_animations.js'},
			{title:'test', hasChild:true, test:'/timob5166/test.js'},
		];
		
		var tableview = Titanium.UI.createTableView({
			data:data
		});
		
		
		tableview.addEventListener('click', function(e)
		{
			if (e.rowData.test)
			{
				var win = Titanium.UI.createWindow({
					url:e.rowData.test,
					title:e.rowData.title,
					backgroundColor:'#fff'
				});
				
				var backButton = Ti.UI.createButton({
					title:"Back",
					height: 50,
					width: 50,
					bottom: 0,
					right: 0
				});
				
				win.add(backButton);
				win.open();
				
				backButton.addEventListener('click', function(){
					win.close();
				});
			}
		});
	  	  
		_window.add(tableview);
		
		return _window;
	};
	
	//
	// TIMOB-7412 Android: V8/Rhino: Animation: Setting animation on a lightweight window makes the window color go transparent
	//
	
	tpl.at.TIMOB7412 = function(_window) {
		_window.backgroundColor = 'black';
		var fromColor = 'green';
		var toColor = 'blue';

		var v = Ti.UI.createView({
			width : '100',
			height : '100',
			backgroundColor : fromColor
		});

		var b = Ti.UI.createButton({
			title : 'Animate',
			bottom : '40',
			left : '10'
		});

		b.addEventListener('click', function() {
			v.animate({
				backgroundColor : toColor,
				duration : 500
			});
		});
		var b1 = Ti.UI.createButton({
			title : 'Reset',
			bottom : '40',
			right : '10'
		});

		b1.addEventListener('click', function() {
			v.backgroundColor = toColor;
			v.backgroundColor = fromColor;
		});
		var v1 = Ti.UI.createView({
			width : '50',
			height : '50',
			backgroundColor : 'white'
		});

		_window.add(v);
		_window.add(b);
		_window.add(b1);
		_window.add(v1);
		return _window;
	}


	tpl.at.TIMOB7416 = function(_window) {
		var view = Ti.UI.createView({
			height : 100,
			width : 100,
			backgroundColor : "green"
		});
		_window.add(view);
		_window.open();

		var matrix = Ti.UI.create2DMatrix();
		var matrix1 = matrix.rotate(120);
		var matrix2 = matrix.rotate(240);
		var transforms = [matrix, matrix1, matrix2];
		// We start at 0, so the first rotation is to 120 degrees
		var nextTransform = 1;
		animation = Ti.UI.createAnimation({
			transform : transforms[nextTransform],
			duration : 500,
		});
		// On iOS, override the default easing to avoid
		// jerky transitions between animations.
		if(Ti.Platform.name === 'iPhone OS') {
			animation.curve = Ti.UI.iOS.ANIMATION_CURVE_LINEAR;
		}

		animation.addEventListener('complete', function(e) {
			// view.transform = transforms[nextTransform];
			if(nextTransform == 0) {
				// Rotation complete, reset for next time
				nextTransform = 1;
				animation.transform = transforms[nextTransform];
			} else {
				// Rotate to the next position
				nextTransform = (nextTransform + 1) % 3;
				animation.transform = transforms[nextTransform];
				view.animate(animation);
			}
		});

		view.addEventListener('click', function(e) {
			view.animate(animation);
		});
		return _window;

	};
	

	tpl.at.TIMOB7517 = function(_window) {
		var box = Ti.UI.createView({
			backgroundColor : 'red',
			height : '150',
			width : '100'
		});

		box.addEventListener('click', function() {
			//alert('Clicked');
			var matrix = Ti.UI.create2DMatrix()
			matrix = matrix.rotate(90);
			matrix = matrix.scale(2, 2);
			var a = Ti.UI.createAnimation({
				transform : matrix,
				duration : 2000,
				autoreverse : true,
				repeat : 3
			});
			box.animate(a);
		});

		_window.add(box);

		return _window;
	};


	
})();